#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-

removecolumns = [
    ('contract_site_address1', 'Address'),
    ('contract_site_city', 'City'),
    ('contract_site_country', 'Country'),
    ('contract_site_customer_name', 'Customer name'),
    ('parent_sr_no', 'Parent S/N'),
    ('service_line_descr', 'Service description'),
    ('contract_site_state_province', 'State/Province'),
    ('warranty_type_description', 'Warranty Description'),
    ('warranty_end_date', 'Warranty end date'),
    ('warranty_type', 'Warranty type'),
]

register_rule('inventory', 'inv_parameters:inv_cisco_contract',
              Dictionary(
                  title=_('Cisco contract staus'),
                  elements=[
                      ('disable_contract',
                       FixedValue(
                           True,
                           title=_('disable Cisco contract inventory'),
                           help=_('if true, CMK will not request contract information from Cisco'),
                       )),
                      ('removecolumns',
                       ListChoice(
                           title=_('remove columns'),
                           label=_('remove columns'),
                           help=_('remove information from report'),
                           choices=removecolumns,
                           default_value=['contract_site_state_province',
                                          'warranty_type_description',
                                          'warranty_end_date',
                                          'warranty_type',
                                          ],
                       )),
                      ('PID_black_list',
                       ListOfStrings(
                           title=_('drop Product IDs beginning with'),
                           orientation='horizontal',
                           help=_('there will be no request for the following PID(s)'),
                       )),
                  ],
              ),
              match='dict',
              )
